!! ##############################################################################################
!!
!! Copyright 2012-2020 CNRS, INPT
!! Copyright 2013-2015 UPS
!!  
!! This file is part of qr_mumps.
!!  
!! qr_mumps is free software: you can redistribute it and/or modify
!! it under the terms of the GNU Lesser General Public License as 
!! published by the Free Software Foundation, either version 3 of 
!! the License, or (at your option) any later version.
!!  
!! qr_mumps is distributed in the hope that it will be useful,
!! but WITHOUT ANY WARRANTY; without even the implied warranty of
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!! GNU Lesser General Public License for more details.
!!  
!! You can find a copy of the GNU Lesser General Public License
!! in the qr_mumps/doc directory.
!!
!! ##############################################################################################

subroutine dqrm_lacpy(transp, a, lda, ia, ja, b, ldb, ib, jb, m, n, l)

  use qrm_parameters_mod
  implicit none

  character    :: transp
  integer      :: lda, ldb, m, n, l, ia, ja, ib, jb
  real(r64) :: a(lda,*),b(ldb,*)

  integer      :: i, j

  if(transp.eq.qrm_transp) then
     do j=1, n
        b(ib+j-1,jb:jb+min(m-l+j,m)-1) = (a(ia:ia+min(m-l+j,m)-1,ja+j-1))
        ! do i=1, min(m-l+j,m)
        ! b(ib+i-1,jb+j-1) = a(ia+i-1,ja+j-1)
        ! end do
     end do
  else
     do j=1, n
        b(ib:ib+min(m-l+j,m)-1,jb+j-1) = a(ia:ia+min(m-l+j,m)-1,ja+j-1)
        ! do i=1, min(m-l+j,m)
        ! b(ib+i-1,jb+j-1) = a(ia+i-1,ja+j-1)
        ! end do
     end do
  end if
     
  return
end subroutine dqrm_lacpy
