!! ##############################################################################################
!!
!! Copyright 2012-2020 CNRS, INPT
!! Copyright 2013-2015 UPS
!!  
!! This file is part of qr_mumps.
!!  
!! qr_mumps is free software: you can redistribute it and/or modify
!! it under the terms of the GNU Lesser General Public License as 
!! published by the Free Software Foundation, either version 3 of 
!! the License, or (at your option) any later version.
!!  
!! qr_mumps is distributed in the hope that it will be useful,
!! but WITHOUT ANY WARRANTY; without even the implied warranty of
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!! GNU Lesser General Public License for more details.
!!  
!! You can find a copy of the GNU Lesser General Public License
!! in the qr_mumps/doc directory.
!!
!! ##############################################################################################

subroutine dqrm_potrf(uplo, m, k, a, lda, info)

  use qrm_parameters_mod
  implicit none
  
  integer      :: lda, m, k
  character    :: uplo
  real(r64) :: a(lda,*)
  integer      :: info

  info = 0
  
  if(uplo.eq.qrm_upper) then
     call dpotrf(uplo, k, a, lda, info)
     if(info .ne. 0) return
     if(m.gt.k) then
        call dtrsm(qrm_left, uplo,         &
             qrm_transp, qrm_no_unit, &
             k, m-k,                       &
             qrm_done,                     &
             a(1,1), lda,                  &
             a(1, k+1), lda)
        call dsyrk(uplo, qrm_transp, &
             m-k, k, &
             qrm_dmone, a(1,k+1), lda, &
             qrm_done , a(k+1, k+1), lda)
     end if
  else
     write(*,*)'qrm_portf with uplo=l not yet implemented'
  end if

  return

end subroutine dqrm_potrf
